package net.minecraftxray.installer;

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.GridLayout;
import java.awt.Toolkit;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.net.URL;
import java.nio.channels.Channels;
import java.nio.channels.ReadableByteChannel;
import java.util.Date;
import java.util.Iterator;
import java.util.List;
import java.util.jar.JarInputStream;
import java.util.jar.JarOutputStream;
import java.util.zip.ZipEntry;
import javax.swing.BorderFactory;
import javax.swing.Icon;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.SwingUtilities;
import javax.swing.UIManager;
import net.minecraftxray.P;
import net.minecraftxray.bN;
import net.minecraftxray.cn;
import net.minecraftxray.co;
import net.minecraftxray.cp;
import net.minecraftxray.q;
import net.minecraftxray.v;
import net.minecraftxray.installer.a;
import net.minecraftxray.installer.b;
import net.minecraftxray.installer.c;
import net.minecraftxray.installer.d;
import net.minecraftxray.installer.e;
import net.minecraftxray.installer.f;
import net.minecraftxray.installer.g;
import net.minecraftxray.loader.h;

public class XRayInstaller {

   private static final net.minecraftxray.b a = new net.minecraftxray.b();
   private final JFrame b;
   private final JComboBox c;
   private final JButton d;
   private final JButton e;
   private int f;


   private XRayInstaller() {
      this.c = new JComboBox();
      this.d = new JButton("Install");
      this.e = new JButton("Update all");
      this.f = 0;
      JPanel var1;
      (var1 = new JPanel(new GridLayout(0, 1, 0, 1))).add(new JLabel("Select the profile you want to install XRay into:"));
      var1.add(this.c);
      JPanel var2;
      (var2 = new JPanel(new GridLayout(1, 0, 2, 0))).add(this.e);
      var2.add(this.d);
      JPanel var3;
      (var3 = new JPanel(new BorderLayout(0, 6))).setBorder(BorderFactory.createEmptyBorder(4, 12, 12, 12));
      var3.add(var1, "Center");
      var3.add(var2, "Last");
      this.b = new JFrame("XRay v58");
      this.b.setDefaultCloseOperation(3);
      this.b.setLocationRelativeTo((Component)null);
      this.b.setResizable(false);
      this.b.setAlwaysOnTop(true);
      this.b.setIconImage(Toolkit.getDefaultToolkit().createImage(XRayInstaller.class.getResource("favicon.png")));
      this.b.setContentPane(var3);
      this.b.getRootPane().setDefaultButton(this.d);
      this.d.setEnabled(false);
      this.e.setEnabled(false);
      this.c.addItem("Loading profiles...");
      this.c.addActionListener(new c(this));
      this.d.addActionListener(new d(this));
      this.e.addActionListener(new e(this));
      (new g(this, (byte)0)).execute();
   }

   private static void a(String var0) {
      File var1 = new File(b.a(), "launcher_profiles.json");

      try {
         InputStreamReader var2 = new InputStreamReader(new FileInputStream(var1), "UTF-8");
         Throwable var3 = null;
         boolean var13 = false;

         try {
            var13 = true;
            v var4 = net.minecraftxray.b.a(var2).h();
            var2.close();
            if(var4.a("profiles")) {
               if(var4.a("selectedProfile")) {
                  String var5 = var4.b("selectedProfile").c();
                  var4.d("profiles").d(var5).a("lastVersionId", var0);
                  bN var29 = new bN(new OutputStreamWriter(new FileOutputStream(var1), "UTF-8"));
                  Throwable var30 = null;
                  boolean var21 = false;

                  try {
                     var21 = true;
                     var29.a("  ");
                     P.a(var4, var29);
                     var21 = false;
                  } catch (Throwable var24) {
                     var30 = var24;
                     throw var24;
                  } finally {
                     if(var21) {
                        if(var30 != null) {
                           try {
                              var29.close();
                           } catch (Throwable var23) {
                              var30.addSuppressed(var23);
                           }
                        } else {
                           var29.close();
                        }

                     }
                  }

                  var29.close();
                  var13 = false;
               } else {
                  var13 = false;
               }
            } else {
               var13 = false;
            }
         } catch (Throwable var26) {
            var3 = var26;
            throw var26;
         } finally {
            if(var13) {
               if(var3 != null) {
                  try {
                     var2.close();
                  } catch (Throwable var22) {
                     var3.addSuppressed(var22);
                  }
               } else {
                  var2.close();
               }

            }
         }

         var2.close();
      } catch (Exception var28) {
         ;
      }
   }

   private static void a(File var0) {
      String var1 = "libraries/net/minecraftxray/xray/58/xray-58.jar";
      if((var0 = new File(var0, var1)).isFile() && !var0.delete()) {
         throw new IOException("Unable to delete the old XRay file: make sure Minecraft is not running.");
      } else {
         URL var26 = XRayInstaller.class.getProtectionDomain().getCodeSource().getLocation();
         var0.getParentFile().mkdirs();
         ReadableByteChannel var27 = Channels.newChannel(var26.openStream());
         Throwable var2 = null;
         boolean var11 = false;

         try {
            var11 = true;
            FileOutputStream var25 = new FileOutputStream(var0);
            Throwable var3 = null;
            boolean var18 = false;

            try {
               var18 = true;
               var25.getChannel().transferFrom(var27, 0L, Long.MAX_VALUE);
               var18 = false;
            } catch (Throwable var21) {
               var3 = var21;
               throw var21;
            } finally {
               if(var18) {
                  if(var3 != null) {
                     try {
                        var25.close();
                     } catch (Throwable var20) {
                        var3.addSuppressed(var20);
                     }
                  } else {
                     var25.close();
                  }

               }
            }

            var25.close();
            var11 = false;
         } catch (Throwable var23) {
            var2 = var23;
            throw var23;
         } finally {
            if(var11) {
               if(var27 != null) {
                  if(var2 != null) {
                     try {
                        var27.close();
                     } catch (Throwable var19) {
                        var2.addSuppressed(var19);
                     }
                  } else {
                     var27.close();
                  }
               }

            }
         }

         if(var27 != null) {
            var27.close();
         }
      }
   }

   private String a(a var1) {
      String var2 = "";

      while(true) {
         while(true) {
            while(true) {
               if(var2.isEmpty()) {
                  var2 = var1.f() + "-XRay";
               }

               if((var2 = (String)JOptionPane.showInputDialog(this.b, "Enter a name for the new modded profile:", this.b.getTitle(), -1, (Icon)null, (Object[])null, var2)) == null) {
                  return null;
               }

               if(!var2.isEmpty()) {
                  if(!var1.f().equalsIgnoreCase(var2)) {
                     if(!b.a((String)var2)) {
                        return var2;
                     }

                     int var3;
                     if((var3 = JOptionPane.showConfirmDialog(this.b, "<html><b>Warning: <u>" + var2 + "</u> already exists!</b><br>If you continue this will be overwritten.<p>Are you sure you want to continue?</html>", "Overwrite?", 1, -1)) != 1) {
                        if(var3 == 2) {
                           return null;
                        }

                        return var2;
                     }
                  } else {
                     JOptionPane.showMessageDialog(this.b, "You must create a different profile than the one you are installing into.", this.b.getTitle(), -1);
                  }
               } else {
                  JOptionPane.showMessageDialog(this.b, "Your new profile name cannot be empty.", this.b.getTitle(), -1);
               }
            }
         }
      }
   }

   private static boolean a(File var0, boolean var1) {
      List var2;
      Iterator var3 = (var2 = b.b((File)var0)).iterator();

      while(var3.hasNext()) {
         if(!((File)var3.next()).delete()) {
            throw new IOException("Unable to delete old XRay file: make sure Minecraft is not running.");
         }
      }

      if(var2.size() <= 0 && var1) {
         return false;
      } else {
         URL var28 = XRayInstaller.class.getProtectionDomain().getCodeSource().getLocation();
         File var4;
         (var4 = new File(var0, "XRay-58.jar")).getParentFile().mkdirs();
         ReadableByteChannel var25 = Channels.newChannel(var28.openStream());
         Throwable var26 = null;
         boolean var11 = false;

         try {
            var11 = true;
            FileOutputStream var27 = new FileOutputStream(var4);
            Throwable var29 = null;
            boolean var18 = false;

            try {
               var18 = true;
               var27.getChannel().transferFrom(var25, 0L, Long.MAX_VALUE);
               var18 = false;
            } catch (Throwable var21) {
               var29 = var21;
               throw var21;
            } finally {
               if(var18) {
                  if(var29 != null) {
                     try {
                        var27.close();
                     } catch (Throwable var20) {
                        var29.addSuppressed(var20);
                     }
                  } else {
                     var27.close();
                  }

               }
            }

            var27.close();
            var11 = false;
         } catch (Throwable var23) {
            var26 = var23;
            throw var23;
         } finally {
            if(var11) {
               if(var25 != null) {
                  if(var26 != null) {
                     try {
                        var25.close();
                     } catch (Throwable var19) {
                        var26.addSuppressed(var19);
                     }
                  } else {
                     var25.close();
                  }
               }

            }
         }

         if(var25 != null) {
            var25.close();
         }

         return true;
      }
   }

   private static void b(a var0) {
      if(var0.j()) {
         a(var0.e(), false);
         a(var0.e().getParentFile(), true);
      } else {
         boolean var1 = a(new File(var0.e(), var0.b()), true);
         a(var0.e(), var1);
      }
   }

   private boolean c(a var1) {
      String var2;
      if((var2 = this.a((a)var1)) == null) {
         return false;
      } else {
         v var3 = new v();
         q var4;
         (var4 = new q()).a(b((String)"net.minecraftxray:xray:58"));
         var4.a(b((String)"net.minecraft:launchwrapper:1.12"));
         if(var1.b().startsWith("1.5") || var1.b().startsWith("1.6")) {
            var4.a(b((String)"org.apache.logging.log4j:log4j-api:2.0-beta9"));
            var4.a(b((String)"org.apache.logging.log4j:log4j-core:2.0-beta9"));
         }

         String var5 = var1.b().startsWith("1.5")?" --tweakClass net.minecraft.launchwrapper.VanillaTweaker --tweakClass net.minecraftxray.loader.XRayTweaker":" --tweakClass net.minecraftxray.loader.XRayTweaker";
         var3.a("id", var2);
         var3.a("time", b.a((Date)(new Date())));
         var3.a("releaseTime", b.a((Date)var1.g()));
         var3.a("type", "release");
         var3.a("minecraftArguments", var1.a() + var5);
         var3.a("libraries", var4);
         var3.a("mainClass", "net.minecraft.launchwrapper.Launch");
         var3.a("minimumLauncherVersion", Integer.valueOf(18));
         var3.a("jar", var1.f());
         var3.a("inheritsFrom", var1.f());
         a((File)b.a());
         File var13;
         (var13 = new File(b.a(), "versions/" + var2 + "/" + var2 + ".json")).getParentFile().mkdirs();
         bN var14 = new bN(new OutputStreamWriter(new FileOutputStream(var13), "UTF-8"));
         Throwable var15 = null;
         boolean var9 = false;

         try {
            var9 = true;
            var14.a("  ");
            P.a(var3, var14);
            var9 = false;
         } catch (Throwable var11) {
            var15 = var11;
            throw var11;
         } finally {
            if(var9) {
               if(var15 != null) {
                  try {
                     var14.close();
                  } catch (Throwable var10) {
                     var15.addSuppressed(var10);
                  }
               } else {
                  var14.close();
               }

            }
         }

         var14.close();
         a((String)var2);
         return true;
      }
   }

   private static void d(a var0) {
      File var1 = new File(b.a(), "versions/" + var0.f() + "/" + var0.f() + ".json");
      InputStreamReader var3 = new InputStreamReader(new FileInputStream(var1), "UTF-8");
      Throwable var4 = null;
      boolean var21 = false;

      v var2;
      try {
         var21 = true;
         var2 = net.minecraftxray.b.a(var3).h();
         var21 = false;
      } catch (Throwable var25) {
         var4 = var25;
         throw var25;
      } finally {
         if(var21) {
            if(var4 != null) {
               try {
                  var3.close();
               } catch (Throwable var22) {
                  var4.addSuppressed(var22);
               }
            } else {
               var3.close();
            }

         }
      }

      var3.close();
      var2.a("time", b.a((Date)(new Date())));
      String var28 = var2.b("minecraftArguments").c().replaceAll("(?i)--tweakClass.+XRayForgeTweaker", "").replaceAll("(?i)--tweakClass.+XRayTweaker", "");
      var28 = var28.trim() + (var0.b().startsWith("1.5")?" --tweakClass net.minecraft.launchwrapper.VanillaTweaker --tweakClass net.minecraftxray.loader.XRayTweaker":" --tweakClass net.minecraftxray.loader.XRayTweaker");
      var2.a("minecraftArguments", var28);
      var2.a("mainClass", "net.minecraft.launchwrapper.Launch");
      q var30 = var2.c("libraries");
      boolean var5 = false;
      boolean var6 = false;

      for(int var29 = 0; var29 < var30.a(); ++var29) {
         String[] var7;
         if(!(var7 = var30.b(var29).h().b("name").c().split(":"))[1].equalsIgnoreCase("launchwrapper") && !var7[1].equalsIgnoreCase("xray")) {
            if(var7[1].equals("log4j-core")) {
               var6 = true;
            } else if(var7[1].equals("log4j-api")) {
               var5 = true;
            }
         } else {
            var30.a(var29--);
         }
      }

      var30.a(b((String)"net.minecraftxray:xray:58"));
      var30.a(b((String)"net.minecraft:launchwrapper:1.12"));
      if(var0.b().startsWith("1.5") || var0.b().startsWith("1.6")) {
         if(!var6) {
            var30.a(b((String)"org.apache.logging.log4j:log4j-core:2.0-beta9"));
         }

         if(!var5) {
            var30.a(b((String)"org.apache.logging.log4j:log4j-api:2.0-beta9"));
         }
      }

      a((File)b.a());
      bN var31 = new bN(new OutputStreamWriter(new FileOutputStream(var1), "UTF-8"));
      Throwable var32 = null;
      boolean var14 = false;

      try {
         var14 = true;
         var31.a("  ");
         P.a(var2, var31);
         var14 = false;
      } catch (Throwable var24) {
         var32 = var24;
         throw var24;
      } finally {
         if(var14) {
            if(var32 != null) {
               try {
                  var31.close();
               } catch (Throwable var23) {
                  var32.addSuppressed(var23);
               }
            } else {
               var31.close();
            }

         }
      }

      var31.close();
   }

   private boolean e(a var1) {
      String var2;
      if((var2 = this.a((a)var1)) == null) {
         return false;
      } else {
         a((File)b.a());
         InputStreamReader var4 = new InputStreamReader(new FileInputStream(new File(b.a(), "versions/" + var1.f() + "/" + var1.f() + ".json")), "UTF-8");
         Throwable var5 = null;
         boolean var60 = false;

         v var3;
         try {
            var60 = true;
            var3 = net.minecraftxray.b.a(var4).h();
            var60 = false;
         } catch (Throwable var66) {
            var5 = var66;
            throw var66;
         } finally {
            if(var60) {
               if(var5 != null) {
                  try {
                     var4.close();
                  } catch (Throwable var64) {
                     var5.addSuppressed(var64);
                  }
               } else {
                  var4.close();
               }

            }
         }

         var4.close();
         File var75 = new File(b.a(), "versions/" + var1.f() + "/" + var1.f() + ".jar");
         File var78 = new File(b.a(), "versions/" + var2 + "/" + var2 + ".jar");
         (new cn("XRay" + h.a(var1.b()).replaceAll("\\.", ""))).a(new net.minecraftxray.loader.a((co)null), 0);
         var78.getParentFile().mkdirs();
         JarInputStream var73 = new JarInputStream(new FileInputStream(var75));
         Throwable var6 = null;
         boolean var34 = false;

         try {
            var34 = true;
            JarOutputStream var76 = new JarOutputStream(new FileOutputStream(var78));
            var5 = null;

            while(true) {
               boolean var47 = false;

               try {
                  var47 = true;
                  ZipEntry var7;
                  if((var7 = var73.getNextEntry()) == null) {
                     var47 = false;
                     break;
                  }

                  if(!var7.getName().startsWith("META-INF")) {
                     var76.putNextEntry(var7);
                     if(var7.getName().endsWith(".class")) {
                        cn var81 = new cn(var73);
                        cp var83 = new cp(var81);
                        var81.a(new net.minecraftxray.loader.a(var83), 0);
                        var76.write(var83.a());
                     } else {
                        byte[] var80 = new byte[8192];

                        int var8;
                        while((var8 = var73.read(var80)) != -1) {
                           var76.write(var80, 0, var8);
                        }
                     }
                  }
               } catch (Throwable var69) {
                  var5 = var69;
                  throw var69;
               } finally {
                  if(var47) {
                     if(var5 != null) {
                        try {
                           var76.close();
                        } catch (Throwable var62) {
                           var5.addSuppressed(var62);
                        }
                     } else {
                        var76.close();
                     }

                  }
               }
            }

            var76.close();
            var34 = false;
         } catch (Throwable var71) {
            var6 = var71;
            throw var71;
         } finally {
            if(var34) {
               if(var6 != null) {
                  try {
                     var73.close();
                  } catch (Throwable var61) {
                     var6.addSuppressed(var61);
                  }
               } else {
                  var73.close();
               }

            }
         }

         var73.close();
         var3.a("id", var2);
         var3.a("time", b.a((Date)(new Date())));
         q var74 = var3.c("libraries");

         for(int var79 = 0; var79 < var74.a(); ++var79) {
            if(var74.b(var79).h().b("name").c().split(":")[1].equalsIgnoreCase("xray")) {
               var74.a(var79--);
            }
         }

         var74.a(b((String)"net.minecraftxray:xray:58"));
         File var82 = new File(b.a(), "versions/" + var2 + "/" + var2 + ".json");
         bN var77 = new bN(new OutputStreamWriter(new FileOutputStream(var82), "UTF-8"));
         var5 = null;
         boolean var21 = false;

         try {
            var21 = true;
            var77.a("  ");
            P.a(var3, var77);
            var21 = false;
         } catch (Throwable var65) {
            var5 = var65;
            throw var65;
         } finally {
            if(var21) {
               if(var5 != null) {
                  try {
                     var77.close();
                  } catch (Throwable var63) {
                     var5.addSuppressed(var63);
                  }
               } else {
                  var77.close();
               }

            }
         }

         var77.close();
         a((String)var2);
         return true;
      }
   }

   private void d() {
      for(int var1 = 0; var1 < this.c.getItemCount(); ++var1) {
         a var2;
         if((var2 = (a)this.c.getItemAt(var1)).h()) {
            if(var2.d()) {
               b((a)var2);
            } else {
               d((a)var2);
            }
         }
      }

   }

   public final void a() {
      this.b.setVisible(true);
      this.b.pack();
   }

   public static void main(String[] var0) {
      SwingUtilities.invokeLater(new f());
   }

   private static v b(String var0) {
      v var1;
      (var1 = new v()).a("name", var0);
      return var1;
   }

   // $FF: synthetic method
   static JComboBox a(XRayInstaller var0) {
      return var0.c;
   }

   // $FF: synthetic method
   static JButton b(XRayInstaller var0) {
      return var0.d;
   }

   // $FF: synthetic method
   static void c(XRayInstaller var0) {
      File var1 = new File(b.a(), "launcher.jar");
      File var2 = new File(b.a(), "launcher.jar.check");
      if(var1.exists()) {
         if(var1.renameTo(var2)) {
            var2.renameTo(var1);
            return;
         }

         JOptionPane.showMessageDialog(var0.b, "It looks like the Minecraft launcher is currently running.\nThis will cause problems with the installation process. Please close Minecraft completely before continuing.", "Warning", 2);
      }

   }

   // $FF: synthetic method
   static void a(XRayInstaller var0, a var1) {
      try {
         if(var1.d()) {
            b((a)var1);
         } else if(var1.h()) {
            if(var0.f > 1) {
               switch(JOptionPane.showConfirmDialog(var0.b, "It appears you have XRay installed in more than one profile.\nWould you like to update all XRay profiles?", "Update all?", 1, -1)) {
               case 0:
                  var0.d();
                  break;
               case 1:
                  d((a)var1);
                  a((String)var1.f());
                  break;
               default:
                  return;
               }
            } else {
               d((a)var1);
               a((String)var1.f());
            }
         } else if(var1.i()) {
            if(!var0.c((a)var1)) {
               return;
            }
         } else if(var1.f().toLowerCase().contains("labymod")) {
            if(!var0.e((a)var1)) {
               return;
            }
         } else {
            String[] var2 = new String[]{"Create a new profile", "Install into " + var1.f(), "Cancel"};
            switch(JOptionPane.showOptionDialog(var0.b, "<html><p>Would you like to create a new profile for XRay, or install XRay directly into " + var1.f() + "?<p>If you choose to create a new profile, the existing profile will be left as is.</html>", var0.b.getTitle(), -1, -1, (Icon)null, var2, (Object)null)) {
            case 0:
               if(!var0.c((a)var1)) {
                  return;
               }
               break;
            case 1:
               d((a)var1);
               a((String)var1.f());
               break;
            default:
               return;
            }
         }

         JOptionPane.showMessageDialog(var0.b, "XRay has been installed/updated successfully!", var0.b.getTitle(), -1);
         var0.b.setVisible(false);
         var0.b.dispose();
      } catch (Exception var3) {
         var3.printStackTrace();
         JOptionPane.showMessageDialog(var0.b, var3.toString(), "Error", 0);
      }
   }

   // $FF: synthetic method
   static void d(XRayInstaller var0) {
      var0.d();
   }

   // $FF: synthetic method
   static JFrame e(XRayInstaller var0) {
      return var0.b;
   }

   // $FF: synthetic method
   static void b() {
      try {
         UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
      } catch (Throwable var1) {
         try {
            UIManager.setLookAndFeel(UIManager.getCrossPlatformLookAndFeelClassName());
         } catch (Throwable var0) {
            ;
         }
      }
   }

   // $FF: synthetic method
   XRayInstaller(byte var1) {
      this();
   }

   // $FF: synthetic method
   static net.minecraftxray.b c() {
      return a;
   }

   // $FF: synthetic method
   static int f(XRayInstaller var0) {
      return var0.f = 0;
   }

   // $FF: synthetic method
   static int g(XRayInstaller var0) {
      ++var0.f;
      return var0.f;
   }

   // $FF: synthetic method
   static int h(XRayInstaller var0) {
      return var0.f;
   }

   // $FF: synthetic method
   static JButton i(XRayInstaller var0) {
      return var0.e;
   }

}
